
// testColor.cxx

#include "testap3.h"
#include <Commdlg.h>

COLORREF	CustColors[16] = {0};


void Set3Edits( HWND hDlg, COLORREF colr, UINT i1, UINT i2, UINT i3 )
{
	UINT	col;

	col = GetRValue( colr ) & 0xff;
	SetDlgItemInt( hDlg,	// handle of dialog box
		i1,			// identifier of control
		col,		// value to set
		FALSE );	// signed or unsigned indicator
	col = GetGValue( colr ) & 0xff;
	SetDlgItemInt( hDlg,	// handle of dialog box
		i2,			// identifier of control
		col,		// value to set
		FALSE );	// signed or unsigned indicator
	col = GetBValue( colr ) & 0xff;
	SetDlgItemInt( hDlg,	// handle of dialog box
		i3,			// identifier of control
		col,		// value to set
		FALSE );	// signed or unsigned indicator
}

COLORREF Get3Edits( HWND hDlg, COLORREF colr, UINT i1, UINT i2, UINT i3 )
{
	BOOL	flg;
	COLORREF	ncolr;
	UINT	col;
	BYTE	br, bg, bb;

	ncolr = 0;
	col = GetDlgItemInt( hDlg,	// handle to dialog box
		i1,			// control identifier
		&flg,		// points to variable to receive success/failure indicator
		FALSE );	// specifies whether value is signed or unsigned
	if( flg && (col < 256) )
		br = (BYTE)col;
	else
		br = GetRValue( colr ) & 0xff;

	col = GetDlgItemInt( hDlg,	// handle to dialog box
		i2,			// control identifier
		&flg,		// points to variable to receive success/failure indicator
		FALSE );	// specifies whether value is signed or unsigned
	if( flg && (col < 256) )
		bg = (BYTE)col;
	else
		bg = GetRValue( colr ) & 0xff;

	col = GetDlgItemInt( hDlg,	// handle to dialog box
		i3,			// control identifier
		&flg,		// points to variable to receive success/failure indicator
		FALSE );	// specifies whether value is signed or unsigned
	if( flg && (col < 256) )
		bb = (BYTE)col;
	else
		bb = GetRValue( colr ) & 0xff;

	ncolr = RGB( br, bg, bb );

	return ncolr;

}

void SetSwishColor( HWND hDlg, COLORREF colr )
{
	Set3Edits( hDlg, colr, IDC_EDIT1, IDC_EDIT2, IDC_EDIT3 );
}
COLORREF GetSwishColor( HWND hDlg, COLORREF colr )
{
	return (Get3Edits( hDlg, colr, IDC_EDIT1, IDC_EDIT2, IDC_EDIT3 ));
}


BOOL Do_GC_Init( HWND hDlg, WPARAM wParam, LPARAM lParam )
{

   SetSwishColor( hDlg, gPenC );
   CenterWindow( hDlg, m_hMainWnd );
   return TRUE;
}

BOOL Do_GC_Close( HWND hDlg )
{
   COLORREF colr = GetSwishColor( hDlg, gPenC );
   if( colr != gPenC ) {
      gPenC = colr;
      gChgPC = TRUE;
   }
   return FALSE;
}

INT_PTR Do_GC_Button( HWND hDlg, WPARAM wParam )
{
   INT_PTR	flg = FALSE;
	CHOOSECOLOR	cc;
	COLORREF	colr, ncolr;
	BYTE	cr, cg, cb;
	BYTE	ncr, ncg, ncb;

	colr = gPenC;
	cr = GetRValue( colr );
	cg = GetGValue( colr );
	cb = GetBValue( colr );

	cc.lStructSize = sizeof( CHOOSECOLOR );
	cc.hwndOwner = hDlg;
	cc.hInstance = (HWND) g_hInst;
	cc.rgbResult = RGB( cr, cg, cb );
	cc.lpCustColors = &CustColors[0]; 
	cc.Flags = CC_ANYCOLOR | CC_RGBINIT;
	cc.lCustData = 0;
	cc.lpfnHook = NULL;
	cc.lpTemplateName = NULL;
	if( ChooseColor( &cc ) ) {
      ncr = GetRValue( cc.rgbResult );
		ncg = GetGValue( cc.rgbResult );
		ncb = GetBValue( cc.rgbResult );
		if((cr != ncr ) ||
			(cg != ncg ) ||
			(cb != ncb ) ) {
         ncolr = RGB( ncr, ncg, ncb );
			SetSwishColor( hDlg, ncolr );
			flg = TRUE;
		}
	}
	return flg;
}


INT_PTR CALLBACK GETCOLORDLGPROC( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	INT_PTR	flg = FALSE;
   DWORD cmd = LOWORD(wParam);
	switch( message )
	{
	case WM_INITDIALOG:
		flg = Do_GC_Init( hDlg, wParam, lParam );
		break;
		
	case WM_COMMAND:
		if( (cmd == IDOK) || (cmd == IDCANCEL) )
		{
			if( cmd == IDOK )
				flg = Do_GC_Close( hDlg );
			EndDialog(hDlg, flg );
		}
		else if( cmd == IDC_BUTTON1 )
		{
			flg = Do_GC_Button( hDlg, wParam );
		}
		break;
	}
	return( flg );
}

VOID Do_Color( HWND hWnd )
{
   COLORREF curr = gPenC;
   INT_PTR i = DialogBoxParam( g_hInst,
			MAKEINTRESOURCE( IDD_GETCOLORS ),
			hWnd,
			GETCOLORDLGPROC,
         0 );
   if(( i == IDOK     ) &&
      ( curr != gPenC ) )
   {
      InvalidateRect( hWnd, NULL, TRUE );
   }
}

// eof - testColor.cxx

