// testContext.cxx

#include "testap3.h"

static MENUITEMINFO sMenuInfo;

/* =====================
IDC_TESTAP3 MENU 
BEGIN
    POPUP "&File"
    BEGIN
        MENUITEM "&Open...",                    IDM_FILEOPEN
        MENUITEM "&Clear",                      IDM_FILECLEAR
        POPUP "&Recent Files"
        BEGIN
            MENUITEM "File1",                       IDM_FILELIST
        END
        MENUITEM "E&xit",                       IDM_EXIT
    END
    POPUP "&Edit"
    BEGIN
        MENUITEM "&Copy",                       IDM_EDITCOPY
        MENUITEM "&Paste",                      IDM_EDITPASTE
    END
    POPUP "&Action"
    BEGIN
        MENUITEM "S&wish",                      IDM_ACTIONTEST
        MENUITEM "&Animate",                    IDM_ACTIONANIM
        MENUITEM "&Stretch",                    IDM_ACTIONSTRETCH
        MENUITEM "&Info...",                    IDM_ACTIONINFO
        MENUITEM "&Color...",                   IDM_ACTIONCOLOR
        MENUITEM "&Options...",                 ID_ACTION_OPTIONS
        MENUITEM "&Magnify Off",                ID_ACTION_MAGOFF
        MENUITEM "&Test",                       IDM_TEST
    END
    POPUP "&Help"
    BEGIN
        MENUITEM "&About ...",                  IDM_ABOUT
    END
END
   ========================= */
enum MENU_ITEMS {
   FILE_MENU = 0,
   EDIT_MENU,
   ACTION_MENU,
   HELP_MENU
};

// handle WM_CONTEXTMENU
#define  AM(a,b)  if(AppendMenu(hMenu,uFlags,a,b))iCnt++

void Do_WM_CONTEXTMENU( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
   HMENU hMenu;
   int x = LOWORD(lParam);
   int y = HIWORD(lParam);
   POINT pnt;
   UINT  uFlags = MF_ENABLED | MF_STRING | MF_BYCOMMAND;
   UINT  iCnt = 0;

   pnt.x = x;
   pnt.y = y;

   // ClientToScreen(hWnd, &pnt); // only for MIDI window!!!
   hMenu = CreatePopupMenu(); // create a POPUP Menu
   if(hMenu) {
      UINT uOpts = TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON;  // allow L/R click/select

      AM(IDM_FILEOPEN, L"&Open...");
      AM(IDM_ACTIONTEST, L"S&wish");
      if( IsMagnifyOn() ) {
         AM( ID_ACTION_MAGOFF, L"&Magnify Off" );
      }
      if( IsClipboardFormatAvailable( CF_DIB ) ||
         IsClipboardFormatAvailable( CF_BITMAP ) ) {
        	AM( IDM_EDITPASTE, L"&Paste" );
      }
      AM(IDM_TEST, L"&Test");
      AM(IDM_EXIT, L"E&xit");
   
      TrackPopupMenu( hMenu,         // handle to shortcut menu
         uOpts,   // TPM_CENTERALIGN | TPM_VCENTERALIGN, // options
         pnt.x,   // horizontal position
         pnt.y,   // vertical position
         0,       // reserved, must be zero
         hWnd,    // handle to owner window
         0 );     // ignored

      DestroyMenu(hMenu);

   }

}

/* ==========================
typedef struct tagMENUITEMINFO {
  UINT    cbSize; 
  UINT    fMask; 
  UINT    fType; 
  UINT    fState; 
  UINT    wID; 
  HMENU   hSubMenu; 
  HBITMAP hbmpChecked; 
  HBITMAP hbmpUnchecked; 
  ULONG_PTR dwItemData; 
  LPTSTR  dwTypeData; 
  UINT    cch; 
  HBITMAP hbmpItem;
} MENUITEMINFO, *LPMENUITEMINFO; 
   ========================= */

// WM_INITMENUPOPUP
#define  mfEnable    ( MF_ENABLED )
#define  mfDisable   ( MF_DISABLED | MF_GRAYED )
#define  EMI(a,b) EnableMenuItem( hmenuPopup, a, MF_BYCOMMAND | (b ? mfEnable : mfDisable) )
#define  CMI(a,b) CheckMenuItem( hmenuPopup, a, (mfEnable | (b ? MF_CHECKED : MF_UNCHECKED)) )


DWORD gdwMaxFiles = 16;
DWORD gdwLastMax = 1;
DWORD gdwlMenuFlag = 1;
#define  M_Fil    1
/* -----------------------------------------------------------------------
	Remove File Name from the 'File' menu pop-up
	for the MAX_FILS configured
   ----------------------------------------------------------------------- */
DWORD DeleteMRU( HMENU hSMenu )
{
	DWORD	cyc, cnt;
	DWORDLONG	bflg = M_Fil ;		/* Init BIT flag - Max 15 shifts left */
	UINT	      fMsg = IDM_FILELIST ;	/* Start IDM_FILE[n] ... */
   cnt = 0;
	for( cyc = 0; cyc < gdwMaxFiles; cyc++ )
	{
		if( gdwlMenuFlag & bflg )
		{
			DeleteMenu( hSMenu, fMsg, MF_BYCOMMAND );
			gdwlMenuFlag &= ~bflg;
         cnt++;
		}
		fMsg++;  // bump to next
		bflg = bflg << 1 ;
	}
   return cnt;
}

/* -----------------------------------------------------------------------
	Add the File Names from the User's preferences buffer -
	Loaded from the ...INI file - to the 'File' Pop-up
	Menu section
   ----------------------------------------------------------------------- */
DWORD AppendMRU( HMENU hSMenu, PLIST_ENTRY pHead )
{
	DWORD	      cnt;
	PTSTR      lps;
	DWORDLONG	bflg;
	UINT	      fMsg;
   PLIST_ENTRY pNext;
	cnt  = 0;
	// NOTE: Should be upper max of say 64 or 128 max!!!
	if( !IsListEmpty(pHead) )
	{
   	bflg = M_Fil;
	   fMsg = IDM_FILELIST ;	// Init IDM_FILE[n] - Max 15 reserved
      Traverse_List( pHead, pNext )
      {
         PFILLST pfl = (PFILLST)pNext;
         lps = &pfl->file[0];
			AppendMenu( hSMenu,
				MF_ENABLED | MF_STRING,
				fMsg,
				lps );
			gdwlMenuFlag |= bflg;
			bflg = bflg << 1;
			fMsg += 1;
			cnt++;
			if( cnt >= gdwMaxFiles )
				break;
		}

      // set the count ADDED to the DROPDOWN MENU ITEM
		gdwLastMax = cnt;	// Keep the COUNT added
      // =============================================

	}
   return cnt;
}


/* -----------------------------------------------------------------------
   DWORD SetFileMRU( HWND hwnd, PLIST_ENTRY pHead )

	Handle 'File' POP-UP changes
	(a) Remove any existing file names
	(b) Add any new list of names
	(c) Check (or Uncheck) the loaded (not loaded) file
   ----------------------------------------------------------------------- */
static HMENU hmenuBar = NULL; 
static HMENU hmenuPopup = NULL; 
static HMENU hmenuFile = NULL;
DWORD GetFileMRU( HWND hWnd )
{
   MENUITEMINFO mii;
   if( hmenuBar == NULL ) {
      // only need to do this ONCE
      hmenuBar = GetMenu(hWnd); 
      ZeroMemory( &mii, sizeof(MENUITEMINFO) );
      mii.cbSize = sizeof(MENUITEMINFO);
      mii.fMask = MIIM_SUBMENU;     // information to get 
      // BOOL GetMenuItemInfo( HMENU hMenu, UINT uItem,
      //                       BOOL fByPosition, LPMENUITEMINFO lpmii );
      GetMenuItemInfo(hmenuBar, FILE_MENU, TRUE, &mii);  // byPosition = T
      hmenuPopup = mii.hSubMenu;
      GetMenuItemInfo(hmenuPopup, 2, TRUE, &mii);  // byPosition = T
      hmenuFile = mii.hSubMenu;
      sprtf( "GetFileMRU: Recent %p is popup of %p sub, of main %p ...\n",
         hmenuFile, hmenuPopup, hmenuBar );
   }

   return 0;
}

DWORD SetFileMRU2( HMENU hSSMenu )
{
   DWORD iRet = 0;
   PLE pHead = GetFileList();
   if(hSSMenu) {
      if( gdwlMenuFlag )	/* If there are previous items */
         DeleteMRU( hSSMenu ) ;	/* Remove them all NOW */
      iRet = AppendMRU( hSSMenu, pHead );
   }
   return iRet;
}

// WM_INITMENUPOPUP
void Do_WM_INITMENUPOPUP( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	BOOL fSystemMenu = (BOOL) HIWORD(lParam); // window menu flag
   if( fSystemMenu ) {
      return;
   } else {
   	HMENU hmenuPopup   = (HMENU) wParam;         // handle of submenu
	   UINT  uPos         = (UINT) LOWORD(lParam);  // submenu item position
      BOOL  bEnab        = TRUE;

      //LPMENUITEMINFO pmi = &sMenuInfo;
      //HMENU hMenu        = GetMenu(hWnd);
      //HMENU hSub         = GetSubMenu( hMenu, FILE_MENU );
      //sprtf( "WM_IPO: Main = %p popup = %p pos = %u %s\n", hMenu, hmenuPopup, uPos,
      //   ((hMenu == hmenuPopup) ? "MAIN" : 
      //   ( hSub == hmenuPopup ) ? "SUB" :
      //   ( hmenuFile == hmenuPopup ) ? "MRU" : "ANOTHER") );

      switch(uPos)
      {
      case FILE_MENU:
         // populate Recent Files sub-menu
         GetFileMRU( hWnd );  // get sub-menu handles
         break;
      case EDIT_MENU:
            bEnab = IsClipboardFormatAvailable( CF_DIB ) ||
		         IsClipboardFormatAvailable( CF_BITMAP );
         	EMI( IDM_EDITPASTE, bEnab );
         break;
      case ACTION_MENU:
         // NOTE: This is level 2 of the 0 'File' menu
         if( hmenuPopup == hmenuFile ) {
            SetFileMRU2( hmenuPopup ); // clean and reset FILE list
         } else {
            CMI( IDM_ACTIONSTRETCH, m_FlagStretch );
            if( IsMagnifyOn() ) {
               EMI( ID_ACTION_MAGOFF, TRUE );
               CMI( ID_ACTION_MAGOFF, TRUE );
            } else {
               EMI( ID_ACTION_MAGOFF, FALSE );
               CMI( ID_ACTION_MAGOFF, FALSE );
            }
         }
         break;
      case HELP_MENU:
         break;
      }
   }
}

// eof - testContext.cxx
