// testDib.cxx

#include "testap3.h"

size_t stBmpCoreHdr = sizeof(BITMAPCOREHEADER);
size_t stBmpInfoHdr = sizeof(BITMAPINFOHEADER);
size_t stBmpV4Hdr   = sizeof(BITMAPV4HEADER);
size_t stBmpV5Hdr   = sizeof(BITMAPV5HEADER);

// #define	Win30_Bmp	(sizeof (BITMAPINFOHEADER))
//#define IS_WIN30_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == Win30_Bmp )
#define IS_CORE_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpCoreHdr )
#define IS_WIN30_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpInfoHdr )
#define IS_V4_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpV4Hdr )
#define IS_V5_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpV5Hdr )

//Bitmap Header Types
//The bitmap has four basic header types: 
// BITMAPCOREHEADER 
// BITMAPINFOHEADER 
// BITMAPV4HEADER 
// BITMAPV5HEADER 
// The four types of bitmap headers are differentiated by the Size member, 
// which is the first DWORD in each of the structures.
//
// Bitmaps that are 16-, 24-, or 32-bpp do not require color tables,
// but may have them to specify colors for palettized devices. If a color
// table is present for 16-, 24-, or 32-bpp bitmap, the biClrUsed member
// specifies the size of the color table and the color table must have
// that many colors in it. If biClrUsed is zero, there is no color table.
// EXCEPT IT SEEMS SOME BITMAP FILES, WITH BI_BITFIELDS, WILL HAVE ZERO,
// but there are then 3 DWORD color mask values at the bits offset address!!!

/* ==========
#define IS_CORE_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpCoreHdr )
BITMAPCOREINFO

The BITMAPCOREINFO structure defines the dimensions and color information for a DIB. 
typedef struct _BITMAPCOREINFO { 
  BITMAPCOREHEADER  bmciHeader; 
  RGBTRIPLE         bmciColors[1]; 
} BITMAPCOREINFO, *PBITMAPCOREINFO; 
Members
bmciHeader 
Specifies a BITMAPCOREHEADER structure that contains information about the 
dimensions and color format of a DIB. 
bmciColors 
Specifies an array of RGBTRIPLE structures that define the colors in the bitmap. 

BITMAPCOREHEADER
The BITMAPCOREHEADER structure contains information about the 
dimensions and color format of a DIB. 
typedef struct tagBITMAPCOREHEADER {
  DWORD   bcSize; 
  WORD    bcWidth; 
  WORD    bcHeight; 
  WORD    bcPlanes; 
  WORD    bcBitCount; 
} BITMAPCOREHEADER, *PBITMAPCOREHEADER; 
Members
bcSize 
Specifies the number of bytes required by the structure. 
bcWidth 
Specifies the width of the bitmap, in pixels. 
bcHeight 
Specifies the height of the bitmap, in pixels. 
bcPlanes 
Specifies the number of planes for the target device. This value must be 1. 
bcBitCount 
Specifies the number of bits-per-pixel. This value must be 1, 4, 8, or 24. 
  =====================

  ====================
#define IS_WIN30_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpInfoHdr )
BITMAPINFOHEADER
The BITMAPINFOHEADER structure contains information about the
dimensions and color format of a DIB. 

Windows 95, Windows NT 4.0: Applications can use the BITMAPV4HEADER 
structure for added functionality. 

Windows 98/Me, Windows 2000/XP: Applications can use the BITMAPV5HEADER 
structure for added functionality. However, these are used only in the 
CreateDIBitmap function.

typedef struct tagBITMAPINFOHEADER{
  DWORD  biSize; 
  LONG   biWidth; 
  LONG   biHeight; 
  WORD   biPlanes; 
  WORD   biBitCount; 
  DWORD  biCompression; 
  DWORD  biSizeImage; 
  LONG   biXPelsPerMeter; 
  LONG   biYPelsPerMeter; 
  DWORD  biClrUsed; 
  DWORD  biClrImportant; 
} BITMAPINFOHEADER, *PBITMAPINFOHEADER; 
Members
biSize 
Specifies the number of bytes required by the structure. 
biWidth 
Specifies the width of the bitmap, in pixels. 
Windows 98/Me, Windows 2000/XP: If biCompression is BI_JPEG or BI_PNG, the 
biWidth member specifies the width of the decompressed JPEG or PNG image file, 
respectively. 

biHeight 
Specifies the height of the bitmap, in pixels. If biHeight is positive, 
the bitmap is a bottom-up DIB and its origin is the lower-left corner.
If biHeight is negative, the bitmap is a top-down DIB and its origin is the
upper-left corner. 
If biHeight is negative, indicating a top-down DIB, biCompression must be
either BI_RGB or BI_BITFIELDS. Top-down DIBs cannot be compressed. 

Windows 98/Me, Windows 2000/XP: If biCompression is BI_JPEG or BI_PNG, the
biHeight member specifies the height of the decompressed JPEG or PNG image 
file, respectively. 

biPlanes 
Specifies the number of planes for the target device. This value must be set to 1. 
biBitCount 
Specifies the number of bits-per-pixel. The biBitCount member of the 
BITMAPINFOHEADER structure determines the number of bits that define each 
pixel and the maximum number of colors in the bitmap. This member must be
one of the following values. 
Value Meaning 
0 Windows 98/Me, Windows 2000/XP: The number of bits-per-pixel is specified
  or is implied by the JPEG or PNG format.  
1 The bitmap is monochrome, and the bmiColors member of BITMAPINFO contains
  two entries. Each bit in the bitmap array represents a pixel. If the bit is
  clear, the pixel is displayed with the color of the first entry in the 
  bmiColors table; if the bit is set, the pixel has the color of the second 
  entry in the table. 
4 The bitmap has a maximum of 16 colors, and the bmiColors member of 
  BITMAPINFO contains up to 16 entries. Each pixel in the bitmap is represented
  by a 4-bit index into the color table. For example, if the first byte in the 
  bitmap is 0x1F, the byte represents two pixels. The first pixel contains the 
  color in the second table entry, and the second pixel contains the color in 
  the sixteenth table entry. 
8 The bitmap has a maximum of 256 colors, and the bmiColors member of 
  BITMAPINFO contains up to 256 entries. In this case, each byte in the array
  represents a single pixel. 
16 The bitmap has a maximum of 2^16 colors. If the biCompression member of
  the BITMAPINFOHEADER is BI_RGB, the bmiColors member of BITMAPINFO is 
  NULL. Each WORD in the bitmap array represents a single pixel. The 
  relative intensities of red, green, and blue are represented with five
  bits for each color component. The value for blue is in the least
  significant five bits, followed by five bits each for green and red.
  The most significant bit is not used. The bmiColors color table is used
  for optimizing colors used on palette-based devices, and must contain
  the number of entries specified by the biClrUsed member of the BITMAPINFOHEADER. 
If the biCompression member of the BITMAPINFOHEADER is BI_BITFIELDS, the
  bmiColors member contains three DWORD color masks that specify the
  red, green, and blue components, respectively, of each pixel. Each
  WORD in the bitmap array represents a single pixel.

Windows NT/Windows 2000/XP: When the biCompression member is BI_BITFIELDS,
  bits set in each DWORD mask must be contiguous and should not overlap
  the bits of another mask. All the bits in the pixel do not have to be used. 

Windows 95/98/Me: When the biCompression member is BI_BITFIELDS, the system
  supports only the following 16bpp color masks: A 5-5-5 16-bit image, where
  the blue mask is 0x001F, the green mask is 0x03E0, and the red mask
  is 0x7C00; and a 5-6-5 16-bit image, where the blue mask is 0x001F,
  the green mask is 0x07E0, and the red mask is 0xF800.
 
24 The bitmap has a maximum of 2^24 colors, and the bmiColors member
  of BITMAPINFO is NULL. Each 3-byte triplet in the bitmap array represents
  the relative intensities of blue, green, and red, respectively, for
  a pixel. The bmiColors color table is used for optimizing colors used
  on palette-based devices, and must contain the number of entries
  specified by the biClrUsed member of the BITMAPINFOHEADER.  
32 The bitmap has a maximum of 2^32 colors. If the biCompression member
  of the BITMAPINFOHEADER is BI_RGB, the bmiColors member of BITMAPINFO is
  NULL. Each DWORD in the bitmap array represents the relative intensities
  of blue, green, and red, respectively, for a pixel. The high byte in each
  DWORD is not used. The bmiColors color table is used for optimizing colors
  used on palette-based devices, and must contain the number of entries
  specified by the biClrUsed member of the BITMAPINFOHEADER. 
  If the biCompression member of the BITMAPINFOHEADER is BI_BITFIELDS,
  the bmiColors member contains three DWORD color masks that specify
  the red, green, and blue components, respectively, of each pixel.
  Each DWORD in the bitmap array represents a single pixel.

Windows NT/ 2000: When the biCompression member is BI_BITFIELDS, bits set
  in each DWORD mask must be contiguous and should not overlap the bits
  of another mask. All the bits in the pixel do not need to be used.

Windows 95/98/Me: When the biCompression member is BI_BITFIELDS, the
  system supports only the following 32-bpp color mask: The blue mask
  is 0x000000FF, the green mask is 0x0000FF00, and the red mask
  is 0x00FF0000. 

biCompression 
Specifies the type of compression for a compressed bottom-up bitmap
 (top-down DIBs cannot be compressed). This member can be one of the
 following values.
Value         Description 
BI_RGB        An uncompressed format. 
BI_RLE8       A run-length encoded (RLE) format for bitmaps with 8 bpp. The
              compression format is a 2-byte format consisting of a count
              byte followed by a byte containing a color index. For more
              information, see Bitmap Compression.  
BI_RLE4       An RLE format for bitmaps with 4 bpp. The compression
              format is a 2-byte format consisting of a count byte followed
              by two word-length color indexes. For more information, see
              Bitmap Compression. 
BI_BITFIELDS  Specifies that the bitmap is not compressed and that the
              color table consists of three DWORD color masks that
              specify the red, green, and blue components, respectively,
              of each pixel. This is valid when used with 16- and 32-bpp bitmaps. 
BI_JPEG       Windows 98/Me, Windows 2000/XP: Indicates that the image
              is a JPEG image. 
BI_PNG        Windows 98/Me, Windows 2000/XP: Indicates that the image is a PNG image. 

biSizeImage 
Specifies the size, in bytes, of the image. This may be set to
 zero for BI_RGB bitmaps. 
Windows 98/Me, Windows 2000/XP: If biCompression is BI_JPEG or BI_PNG,
 biSizeImage indicates the size of the JPEG or PNG image buffer, respectively. 

biXPelsPerMeter 
Specifies the horizontal resolution, in pixels-per-meter, of the target
 device for the bitmap. An application can use this value to select a
 bitmap from a resource group that best matches the characteristics of
 the current device. 
biYPelsPerMeter 
Specifies the vertical resolution, in pixels-per-meter, of the target
 device for the bitmap. 
biClrUsed 
Specifies the number of color indexes in the color table that are actually
 used by the bitmap. If this value is zero, the bitmap uses the maximum
 number of colors corresponding to the value of the biBitCount member for
 the compression mode specified by biCompression. 
If biClrUsed is nonzero and the biBitCount member is less than 16, the
 biClrUsed member specifies the actual number of colors the graphics
 engine or device driver accesses. If biBitCount is 16 or greater, the
 biClrUsed member specifies the size of the color table used to optimize
 performance of the system color palettes. If biBitCount equals 16 or 32,
 the optimal color palette starts immediately following the three DWORD masks. 

When the bitmap array immediately follows the BITMAPINFO structure, it is
 a packed bitmap. Packed bitmaps are referenced by a single pointer. Packed
 bitmaps require that the biClrUsed member must be either zero or the actual
 size of the color table. 

biClrImportant 
Specifies the number of color indexes that are required for displaying the
 bitmap. If this value is zero, all colors are required. 
Remarks
The BITMAPINFO structure combines the BITMAPINFOHEADER structure and a
 color table to provide a complete definition of the dimensions and colors of
 a DIB. For more information about DIBs, see Device-Independent Bitmaps
 and BITMAPINFO. 

An application should use the information stored in the biSize member to
 locate the color table in a BITMAPINFO structure, as follows: 
 pColor = ((LPSTR)pBitmapInfo + (WORD)(pBitmapInfo->bmiHeader.biSize));
  =====================

  ====================
#define IS_V4_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpV4Hdr )
BITMAPV4HEADER
The BITMAPV4HEADER structure is the bitmap information header file. It
 is an extended version of the BITMAPINFOHEADER structure. 
Windows NT 3.51 and earlier: Applications should continue to use BITMAPINFOHEADER. 
Windows 98/Me, Windows 2000/XP: Applications can use the BITMAPV5HEADER
 structure for added functionality. 
typedef struct {
  DWORD        bV4Size;
  LONG         bV4Width;
  LONG         bV4Height;
  WORD         bV4Planes;
  WORD         bV4BitCount;
  DWORD        bV4V4Compression;
  DWORD        bV4SizeImage;
  LONG         bV4XPelsPerMeter;
  LONG         bV4YPelsPerMeter;
  DWORD        bV4ClrUsed;
  DWORD        bV4ClrImportant;
  DWORD        bV4RedMask;
  DWORD        bV4GreenMask;
  DWORD        bV4BlueMask;
  DWORD        bV4AlphaMask;
  DWORD        bV4CSType;
  CIEXYZTRIPLE bV4Endpoints;
  DWORD        bV4GammaRed;
  DWORD        bV4GammaGreen;
  DWORD        bV4GammaBlue;
} BITMAPV4HEADER, *PBITMAPV4HEADER; 
Members
bV4Size 
Specifies the number of bytes required by the structure. Applications should
 use this member to determine which bitmap information header structure is being used. 
bV4Width 
Specifies the width of the bitmap, in pixels. 
Windows 98/Me, Windows 2000/XP: If bV4Compression is BI_JPEG or BI_PNG, bV4Width
 specifies the width of the JPEG or PNG image in pixels. 

bV4Height 
Specifies the height of the bitmap, in pixels. If bV4Height is positive, the
 bitmap is a bottom-up DIB and its origin is the lower-left corner. If bV4Height
 is negative, the bitmap is a top-down DIB and its origin is the upper-left corner. 
If bV4Height is negative, indicating a top-down DIB, bV4Compression must be
 either BI_RGB or BI_BITFIELDS. Top-down DIBs cannot be compressed. 

Windows 98/Me, Windows 2000/XP: If bV4Compression is BI_JPEG or BI_PNG, bV4Height
 specifies the height of the JPEG or PNG image in pixels. 

bV4Planes 
Specifies the number of planes for the target device. This value must be set to 1. 
bV4BitCount 
Specifies the number of bits-per-pixel. The bV4BitCount member of the
 BITMAPV4HEADER structure determines the number of bits that define each
 pixel and the maximum number of colors in the bitmap. This member must be
 one of the following values.
Value Meaning 
0     Windows 98/Me, Windows 2000/XP: The number of bits-per-pixel is
      specified or is implied by the JPEG or PNG file format.  
1     The bitmap is monochrome, and the bmiColors member of BITMAPINFO contains
      two entries. Each bit in the bitmap array represents a pixel. If the bit
      is clear, the pixel is displayed with the color of the first entry in the
      bmiColors table; if the bit is set, the pixel has the color of the second
      entry in the table. 
4     The bitmap has a maximum of 16 colors, and the bmiColors member of
      BITMAPINFO contains up to 16 entries. Each pixel in the bitmap is represented
      by a 4-bit index into the color table. For example, if the first byte in
      the bitmap is 0x1F, the byte represents two pixels. The first pixel
      contains the color in the second table entry, and the second pixel
      contains the color in the sixteenth table entry. 
8     The bitmap has a maximum of 256 colors, and the bmiColors member of
      BITMAPINFO contains up to 256 entries. In this case, each byte in the array
      represents a single pixel. 
16    The bitmap has a maximum of 2^16 colors. If the bV4Compression member of
      the BITMAPV4HEADER structure is BI_RGB, the bmiColors member of BITMAPINFO
      is NULL. Each WORD in the bitmap array represents a single pixel. The
      relative intensities of red, green, and blue are represented with five
      bits for each color component. The value for blue is in the least
      significant five bits, followed by five bits each for green and red,
      respectively. The most significant bit is not used. The bmiColors color
      table is used for optimizing colors used on palette-based devices, and
      must contain the number of entries specified by the bV4ClrUsed member of
      the BITMAPV4HEADER. 
      If the bV4Compression member of the BITMAPV4HEADER is BI_BITFIELDS, the
       bmiColors member contains three DWORD color masks that specify the red,
       green, and blue components of each pixel. Each WORD in the bitmap array
       represents a single pixel.
 
24    The bitmap has a maximum of 2^24 colors, and the bmiColors member of
      BITMAPINFO is NULL. Each 3-byte triplet in the bitmap array represents
      the relative intensities of blue, green, and red for a pixel. The
      bmiColors color table is used for optimizing colors used on
      palette-based devices, and must contain the number of entries specified
      by the bV4ClrUsed member of the BITMAPV4HEADER.  
32    The bitmap has a maximum of 2^32 colors. If the bV4Compression member of
      the BITMAPV4HEADER is BI_RGB, the bmiColors member of BITMAPINFO is NULL.
      Each DWORD in the bitmap array represents the relative intensities of blue,
      green, and red for a pixel. The high byte in each DWORD is not used. The
      bmiColors color table is used for optimizing colors used on palette-based
      devices, and must contain the number of entries specified by the biClrUsed
      member of the BITMAPV4HEADER. 
      If the bV4Compression member of the BITMAPV4HEADER is BI_BITFIELDS, the
      bmiColors member contains three DWORD color masks that specify the red,
      green, and blue components of each pixel. Each DWORD in the bitmap array
      represents a single pixel.

bV4V4Compression 
Specifies the type of compression for a compressed bottom-up bitmap (top-down
DIBs cannot be compressed). This member can be one of the following values.
Value        Description 
BI_RGB       An uncompressed format. 
BI_RLE8      A run-length encoded (RLE) format for bitmaps with 8 bpp. The compression
             format is a 2-byte format consisting of a count byte followed by a byte
             containing a color index. For more information, see Bitmap Compression. 
BI_RLE4      An RLE format for bitmaps with 4 bpp. The compression format is a 2-byte
             format consisting of a count byte followed by two word-length color
             indexes. For more information, see Bitmap Compression. 
BI_BITFIELDS Specifies that the bitmap is not compressed. The members bV4RedMask,
             bV4GreenMask, and bV4BlueMask specify the red, green, and blue
             components for each pixel. This is valid when used with 16- and
             32-bpp bitmaps. 
BI_JPEG      Windows 98/Me, Windows 2000/XP: Specifies that the image is
             compressed using the JPEG file interchange format. JPEG compression
             trades off compression against loss; it can achieve a compression
             ratio of 20:1 with little noticeable loss.  
BI_PNG       Windows 98/Me, Windows 2000/XP: Specifies that the image is
             compressed using the PNG file interchange format.  

bV4SizeImage 
Specifies the size, in bytes, of the image. This may be set to zero for
BI_RGB bitmaps. 
Windows 98/Me, Windows 2000/XP: If bV4Compression is BI_JPEG or BI_PNG,
bV4SizeImage is the size of the JPEG or PNG image buffer. 

bV4XPelsPerMeter 
Specifies the horizontal resolution, in pixels-per-meter, of the target device
for the bitmap. An application can use this value to select a bitmap from a
resource group that best matches the characteristics of the current device. 
bV4YPelsPerMeter 
Specifies the vertical resolution, in pixels-per-meter, of the target device
for the bitmap. 
bV4ClrUsed 
Specifies the number of color indexes in the color table that are actually used
by the bitmap. If this value is zero, the bitmap uses the maximum number of
colors corresponding to the value of the bV4BitCount member for the compression
mode specified by bV4Compression. 
If bV4ClrUsed is nonzero and the bV4BitCount member is less than 16, the
bV4ClrUsed member specifies the actual number of colors the graphics engine
or device driver accesses. If bV4BitCount is 16 or greater, the bV4ClrUsed
member specifies the size of the color table used to optimize performance of
the system color palettes. If bV4BitCount equals 16 or 32, the optimal color
palette starts immediately following the BITMAPV4HEADER. 

bV4ClrImportant 
Specifies the number of color indexes that are required for displaying the
bitmap. If this value is zero, all colors are important. 
bV4RedMask 
Color mask that specifies the red component of each pixel, valid only if
bV4Compression is set to BI_BITFIELDS. 
bV4GreenMask 
Color mask that specifies the green component of each pixel, valid only
if bV4Compression is set to BI_BITFIELDS. 
bV4BlueMask 
Color mask that specifies the blue component of each pixel, valid only
if bV4Compression is set to BI_BITFIELDS. 
bV4AlphaMask 
Color mask that specifies the alpha component of each pixel. 
bV4CSType 
Specifies the color space of the DIB. The following table lists the value for
bV4CSType.
Value              Meaning 
LCS_CALIBRATED_RGB This value indicates that endpoints and gamma values are
                   given in the appropriate fields.  
See the LOGCOLORSPACE structure for information that defines a logical color space. 
bV4Endpoints 
A CIEXYZTRIPLE structure that specifies the x, y, and z coordinates of the
three colors that correspond to the red, green, and blue endpoints for the
logical color space associated with the bitmap. This member is ignored unless
the bV4CSType member specifies LCS_CALIBRATED_RGB. 
Note  A color space is a model for representing color numerically in terms of
three or more coordinates. For example, the RGB color space represents colors
in terms of the red, green, and blue coordinates. 
bV4GammaRed 
Toned response curve for red. This member is ignored unless color values are
calibrated RGB values and bV4CSType is set to LCS_CALIBRATED_RGB. Specified
in 16^16 format. 
bV4GammaGreen 
Toned response curve for green. Used if bV4CSType is set to LCS_CALIBRATED_RGB.
Specified as 16^16 format. 
bV4GammaBlue 
Toned response curve for blue. Used if bV4CSType is set to LCS_CALIBRATED_RGB.
Specified as 16^16 format. 
Remarks
Windows 98/Me, Windows 2000/XP: The BITMAPV4HEADER structure is extended to
allow a JPEG or PNG image to be passed as the source image to StretchDIBits. 
  =====================

  ====================
#define IS_V5_DIB(lpbi)  ( (*(LPDWORD) (lpbi)) == stBmpV5Hdr )
BITMAPV5HEADER
The BITMAPV5HEADER structure is the bitmap information header file. It is
 an extended version of the BITMAPINFOHEADER structure.
Windows 95 and Windows NT 4.0: Applications can use the BITMAPV4HEADER structure. 
Windows NT 3.51 and earlier: Applications should continue to use BITMAPINFOHEADER. 
typedef struct { 
  DWORD        bV5Size; 
  LONG         bV5Width; 
  LONG         bV5Height; 
  WORD         bV5Planes; 
  WORD         bV5BitCount; 
  DWORD        bV5Compression; 
  DWORD        bV5SizeImage; 
  LONG         bV5XPelsPerMeter; 
  LONG         bV5YPelsPerMeter; 
  DWORD        bV5ClrUsed; 
  DWORD        bV5ClrImportant; 
  DWORD        bV5RedMask; 
  DWORD        bV5GreenMask; 
  DWORD        bV5BlueMask; 
  DWORD        bV5AlphaMask; 
  DWORD        bV5CSType; 
  CIEXYZTRIPLE bV5Endpoints; 
  DWORD        bV5GammaRed; 
  DWORD        bV5GammaGreen; 
  DWORD        bV5GammaBlue; 
  DWORD        bV5Intent; 
  DWORD        bV5ProfileData; 
  DWORD        bV5ProfileSize; 
  DWORD        bV5Reserved; 
} BITMAPV5HEADER, *PBITMAPV5HEADER; 
Members
bV5Size 
Specifies the number of bytes required by the structure. Applications should
use this member to determine which bitmap information header structure is being used. 
bV5Width 
Specifies the width of the bitmap, in pixels. 
If bV5Compression is BI_JPEG or BI_PNG, the bV5Width member specifies the width
of the decompressed JPEG or PNG image in pixels. 
bV5Height 
Specifies the height of the bitmap, in pixels. If the value of bV5Height
is positive, the bitmap is a bottom-up DIB and its origin is the lower-left corner.
If bV5Height value is negative, the bitmap is a top-down DIB and its origin is
the upper-left corner. 
If bV5Height is negative, indicating a top-down DIB, bV5Compression must be
either BI_RGB or BI_BITFIELDS. Top-down DIBs cannot be compressed. 
If bV5Compression is BI_JPEG or BI_PNG, the bV5Height member specifies the
height of the decompressed JPEG or PNG image in pixels. 
bV5Planes 
Specifies the number of planes for the target device. This value must be set to 1. 
bV5BitCount 
Specifies the number of bits that define each pixel and the maximum number of
colors in the bitmap. 
This member can be one of the following values.
Value Meaning 
0     The number of bits per pixel is specified or is implied by the JPEG or
      PNG file format. 
1     The bitmap is monochrome, and the bmiColors member of BITMAPINFO contains
      two entries. Each bit in the bitmap array represents a pixel. If the bit
      is clear, the pixel is displayed with the color of the first entry in the
      bmiColors color table. If the bit is set, the pixel has the color of the
      second entry in the table. 
4     The bitmap has a maximum of 16 colors, and the bmiColors member of BITMAPINFO
      contains up to 16 entries. Each pixel in the bitmap is represented by a 4-bit
      index into the color table. For example, if the first byte in the bitmap
      is 0x1F, the byte represents two pixels. The first pixel contains the color
      in the second table entry, and the second pixel contains the color in the
      sixteenth table entry. 
8     The bitmap has a maximum of 256 colors, and the bmiColors member of BITMAPINFO
      contains up to 256 entries. In this case, each byte in the array represents a
      single pixel. 
16    The bitmap has a maximum of 2^16 colors. If the bV5Compression member of the
      BITMAPV5HEADER structure is BI_RGB, the bmiColors member of BITMAPINFO is
      NULL. Each WORD in the bitmap array represents a single pixel. The relative
      intensities of red, green, and blue are represented with five bits for each
      color component. The value for blue is in the least significant five bits,
      followed by five bits each for green and red. The most significant bit is
      not used. The bmiColors color table is used for optimizing colors used on
      palette-based devices, and must contain the number of entries specified by
      the bV5ClrUsed member of the BITMAPV5HEADER. 
      If the bV5Compression member of the BITMAPV5HEADER is BI_BITFIELDS, the
      bmiColors member contains three DWORD color masks that specify the red,
      green, and blue components, respectively, of each pixel. Each WORD in the
      bitmap array represents a single pixel.
      When the bV5iCompression member is BI_BITFIELDS, bits set in each DWORD
      mask must be contiguous and should not overlap the bits of another mask. All
      the bits in the pixel do not need to be used. 
24    The bitmap has a maximum of 2^24 colors, and the bmiColors member of
      BITMAPINFO is NULL. Each 3-byte triplet in the bitmap array represents
      the relative intensities of blue, green, and red, respectively, for a pixel.
      The bmiColors color table is used for optimizing colors used on palette-based
      devices, and must contain the number of entries specified by the bV5ClrUsed
      member of the BITMAPV5HEADER structure.  
32    The bitmap has a maximum of 2^32 colors. If the bV5Compression member of
      the BITMAPV5HEADER is BI_RGB, the bmiColors member of BITMAPINFO is NULL.
      Each DWORD in the bitmap array represents the relative intensities of blue,
      green, and red, respectively, for a pixel. The high byte in each DWORD is not
      used. The bmiColors color table is used for optimizing colors used on
      palette-based devices, and must contain the number of entries specified by
      the bV5ClrUsed member of the BITMAPV5HEADER. 
      If the bV5Compression member of the BITMAPV5HEADER is BI_BITFIELDS, the
      bmiColors member contains three DWORD color masks that specify the red,
      green, and blue components of each pixel. Each DWORD in the bitmap array
      represents a single pixel.

bV5Compression 
Specifies that the bitmap is not compressed. The bV5RedMask, bV5GreenMask,
and bV5BlueMask members specify the red, green, and blue components of each
pixel. This is valid when used with 16- and 32-bpp bitmaps. This member can be
one of the following values.
Value        Meaning 
BI_RGB       An uncompressed format. 
BI_RLE8      A run-length encoded (RLE) format for bitmaps with 8 bpp. The
             compression format is a two-byte format consisting of a count byte
             followed by a byte containing a color index. If bV5Compression is
             BI_RGB and the bV5BitCount member is 16, 24, or 32, the bitmap array
             specifies the actual intensities of blue, green, and red rather than
             using color table indexes. For more information, see Bitmap Compression. 
BI_RLE4      An RLE format for bitmaps with 4 bpp. The compression format is a
             two-byte format consisting of a count byte followed by two word-length
             color indexes. For more information, see Bitmap Compression. 
BI_BITFIELDS Specifies that the bitmap is not compressed and that the color table
             consists of three DWORD color masks that specify the red, green, and
             blue components of each pixel. Valid when used with 16- and 32-bpp
             bitmaps. 
BI_JPEG      Specifies that the image is compressed using the JPEG file Interchange
             Format. JPEG compression trades off compression against loss; it can
             achieve a compression ratio of 20:1 with little noticeable loss.  
BI_PNG       Specifies that the image is compressed using the PNG file
             Interchange Format. 

bV5SizeImage 
Specifies the size, in bytes, of the image. This may be set to zero for 
BI_RGB bitmaps. 
If bV5Compression is BI_JPEG or BI_PNG, bV5SizeImage is the size of the
JPEG or PNG image buffer. 

bV5XPelsPerMeter 
Specifies the horizontal resolution, in pixels-per-meter, of the target device
for the bitmap. An application can use this value to select a bitmap from a
resource group that best matches the characteristics of the current device. 
bV5YPelsPerMeter 
Specifies the vertical resolution, in pixels-per-meter, of the target device
for the bitmap. 
bV5ClrUsed 
Specifies the number of color indexes in the color table that are actually used
by the bitmap. If this value is zero, the bitmap uses the maximum number of
colors corresponding to the value of the bV5BitCount member for the compression
mode specified by bV5Compression. 
If bV5ClrUsed is nonzero and bV5BitCount is less than 16, the bV5ClrUsed
member specifies the actual number of colors the graphics engine or device
driver accesses. If bV5BitCount is 16 or greater, the bV5ClrUsed member specifies
the size of the color table used to optimize performance of the system color
palettes. If bV5BitCount equals 16 or 32, the optimal color palette starts
immediately following the BITMAPV5HEADER. If bV5ClrUsed is nonzero, the color
table is used on palettized devices, and bV5ClrUsed specifies the number of entries. 

bV5ClrImportant 
Specifies the number of color indexes that are required for displaying the bitmap.
If this value is zero, all colors are required. 
bV5RedMask 
Color mask that specifies the red component of each pixel, valid only if
bV5Compression is set to BI_BITFIELDS. 
bV5GreenMask 
Color mask that specifies the green component of each pixel, valid only if
bV5Compression is set to BI_BITFIELDS. 
bV5BlueMask 
Color mask that specifies the blue component of each pixel, valid only
if bV5Compression is set to BI_BITFIELDS. 
bV5AlphaMask 
Color mask that specifies the alpha component of each pixel. 
bV5CSType 
Specifies the color space of the DIB. 
The following table specifies the values for bV5CSType.
Value              Meaning 
LCS_CALIBRATED_RGB This value implies that endpoints and gamma values are given
                   in the appropriate fields. 
LCS_sRGB           Specifies that the bitmap is in sRGB color space.  
LCS_WINDOWS_COLOR_SPACE This value indicates that the bitmap is in the system
                   default color space, sRGB.  
PROFILE_LINKED     This value indicates that bV5ProfileData points to the file
                   name of the profile to use (gamma and endpoints values are ignored).  
PROFILE_EMBEDDED   This value indicates that bV5ProfileData points to a memory
                   buffer that contains the profile to be used (gamma and endpoints
                   values are ignored). 
See the LOGCOLORSPACE structure for information that defines a logical color space. 

bV5Endpoints 
A CIEXYZTRIPLE structure that specifies the x, y, and z coordinates of the
three colors that correspond to the red, green, and blue endpoints for the
logical color space associated with the bitmap. This member is ignored unless
the bV5CSType member specifies LCS_CALIBRATED_RGB. 
bV5GammaRed 
Toned response curve for red. Used if bV5CSType is set to LCS_CALIBRATED_RGB.
Specified in 16^16 format. 
bV5GammaGreen 
Toned response curve for green. Used if bV5CSType is set to LCS_CALIBRATED_RGB.
Specified in 16^16 format. 
bV5GammaBlue 
Toned response curve for blue. Used if bV5CSType is set to LCS_CALIBRATED_RGB.
Specified in 16^16 format. 
bV5Intent 
Rendering intent for bitmap. This can be one of the following values. 
Value Intent            ICC name Meaning 
LCS_GM_ABS_COLORIMETRIC Match Absolute Colorimetric Maintains the white point.
                        Matches the colors to their nearest color in the
                        destination gamut. 
LCS_GM_BUSINESS         Graphic Saturation Maintains saturation. Used for
                        business charts and other situations in which undithered
                        colors are required. 
LCS_GM_GRAPHICS         Proof Relative Colorimetric Maintains colorimetric
                        match. Used for graphic designs and named colors. 
LCS_GM_IMAGES           Picture Perceptual Maintains contrast. Used for
                        photographs and natural images. 

bV5ProfileData 
The offset, in bytes, from the beginning of the BITMAPV5HEADER structure to
the start of the profile data. If the profile is embedded, profile data is the
actual profile, and it is linked. (The profile data is the null-terminated
file name of the profile.) This cannot be a Unicode string. It must be
composed exclusively of characters from the Windows character set (code page 1252).
These profile members are ignored unless the bV5CSType member specifies
PROFILE_LINKED or PROFILE_EMBEDDED. 
bV5ProfileSize 
Size, in bytes, of embedded profile data. 
bV5Reserved 
This member has been reserved. Its value should be set to zero. 
Remarks
If bV5Height is negative, indicating a top-down DIB, bV5Compression must be
either BI_RGB or BI_BITFIELDS. Top-down DIBs cannot be compressed.

The Independent Color Management interface (ICM) 2.0 allows International
Color Consortium (ICC) color profiles to be linked or embedded in DIBs (DIBs).
See Using Structures in ICM 2.0 for more information. 

When a DIB is loaded into memory, the profile data (if present) should
follow the color table, and the bV5ProfileData should provide the offset
of the profile data from the beginning of the BITMAPV5HEADER structure. The
value stored in bV5ProfileDate will be different from the value returned by
the sizeof operator given the BITMAPV5HEADER argument, because bV5ProfileData
is the offset in bytes from the beginning of the BITMAPV5HEADER structure to
the start of the profile data. (Bitmap bits do not follow the color table in
memory). Applications should modify the bV5ProfileData member after loading the
DIB into memory. 

For packed DIBs, the profile data should follow the bitmap bits similar to the
file format. The bV5ProfileData member should still give the offset of the
profile data from the beginning of the BITMAPV5HEADER. 

Applications should access the profile data only when bV5Size equals the size
of the BITMAPV5HEADER and bV5CSType equals PROFILE_EMBEDDED or PROFILE_LINKED.

If a profile is linked, the path of the profile can be any fully qualified
name (including a network path) that can be opened using the CreateFile function. 
   ==================== */

void Out_Bmp_Hdr_Size( void )
{
   sprtf( "BITMAP Headers: CORE=%d, INFO=%d, V4=%d, V5=%d\n",
      stBmpCoreHdr, stBmpInfoHdr, stBmpV4Hdr, stBmpV5Hdr );
}

BOOL Process_DIB( HWND hWnd, HANDLE hDIB, HDC hdc)
{
   BOOL bRet = FALSE;
   HBITMAP hbm = BitmapFromDib( hDIB, NULL );
   if( hbm ) {
      if( m_hDIB ) {
         //delete m_hDIB;
         MFREE(m_hDIB);
      }
      if( m_hBitmap )
         DeleteObject(m_hBitmap);

      m_sDIBSize.cx = (LONG)DIBWidth (hDIB);
      m_sDIBSize.cy = (LONG)DIBHeight(hDIB);
      m_hDIB        = hDIB;
      m_hBitmap     = hbm;
   }
   if( m_hBitmap && hbm ) {
      DrawBitmap( hdc, 0, 0, m_hBitmap, SRCCOPY ); // COPY it to the screen/window
      // this is to adjust SCROLL BARS, if BITMAP larger than window
      PostMessage( hWnd, WM_SIZE, 0, MAKELONG( g_wm_size.cx, g_wm_size.cy ));
      bRet = TRUE;
   }
   return bRet;
}

size_t DIBWidth (void * lpDIB)
{
   LPBITMAPINFOHEADER lpbmi;
   LPBITMAPCOREHEADER lpbmc;
   lpbmi = (LPBITMAPINFOHEADER) lpDIB;
   lpbmc = (LPBITMAPCOREHEADER) lpDIB;
   if (lpbmi->biSize == sizeof (BITMAPINFOHEADER))
      return lpbmi->biWidth;
   else
      return lpbmc->bcWidth;
}

size_t DIBHeight (void * lpDIB)
{
   LPBITMAPINFOHEADER lpbmi;
   LPBITMAPCOREHEADER lpbmc;
   lpbmi = (LPBITMAPINFOHEADER) lpDIB;
   lpbmc = (LPBITMAPCOREHEADER) lpDIB;
   if (lpbmi->biSize == sizeof (BITMAPINFOHEADER))
      return lpbmi->biHeight;
   else
      return lpbmc->bcHeight;
}

DWORD	OffsetToColor( LPSTR lpbi )
{
//	return( *(LPDWORD)lpbi );
	DWORD	   dwi;
	LPDWORD	lpdw;

	lpdw = (LPDWORD)lpbi;
	dwi = *lpdw;
	if(( dwi == sizeof(BITMAPINFOHEADER) ) ||
		( dwi == sizeof(BITMAPCOREHEADER) ) )
	{
		/* this is ok */
	}
	else
	{
		dwi = sizeof(BITMAPINFOHEADER);
	}
	return dwi;
}

DWORD	OffsetToBits( LPSTR lpbi )
{
	return( OffsetToColor(lpbi) + PaletteSize(lpbi) );
}

LPSTR FindDIBBits (LPSTR lpbi)
{
   return( lpbi + OffsetToBits( lpbi ));
}

size_t DIBNumColors ( void * pv )
{
   INT                 bits;
   LPBITMAPINFOHEADER  lpbi;
   LPBITMAPCOREHEADER  lpbc;

   lpbi = ((LPBITMAPINFOHEADER)pv);
   lpbc = ((LPBITMAPCOREHEADER)pv);

   /*  With the BITMAPINFO format headers, the size of the palette
    *  is in biClrUsed, whereas in the BITMAPCORE - style headers, it
    *  is dependent on the bits per pixel ( = 2 raised to the power of
    *  bits/pixel).
    */
   if (lpbi->biSize != sizeof(BITMAPCOREHEADER)){
        if (lpbi->biClrUsed != 0)
            return (WORD)lpbi->biClrUsed;
        bits = lpbi->biBitCount;
    } else
        bits = lpbc->bcBitCount;

    switch (bits)
    {
    case 1: return 2;
    case 4: return 16;
    case 8: return 256;
    /* A 24 bitcount DIB has no color table */
    }
    return 0;
}


// BMPToDIB - BitmapToDIB - Bitmap2dib - (HANDLE)Bitmap to DIB
// NOTE: Uses 'new' to get memory, use 'delete' to free.
// USE DVBitmapToDIB to use GlobalAlloc to get memory!
// ==================================================
HANDLE BMPToDIB( HBITMAP hBitmap, HPALETTE hPal )
{
	BITMAP				Bitmap;
	BITMAPINFOHEADER	bmInfoHdr;
	LPBITMAPINFOHEADER	lpbmInfoHdr;
	LPSTR				lpBits;
	HDC					hMemDC;
	HANDLE				hDIB;
	HPALETTE			hOldPal;
   size_t         dwSize;

	// Do some setup -- make sure the Bitmap passed in is valid,
	//  get info on the bitmap (like its height, width, etc.),
	//  then setup a BITMAPINFOHEADER.
	hOldPal = NULL;
	hDIB    = NULL;

	if( !hBitmap )
		return hDIB;

	if( !GetObject( hBitmap, sizeof(Bitmap), (LPSTR)&Bitmap ) )
		return hDIB;

	InitBitmapInfoHeader( &bmInfoHdr,
		Bitmap.bmWidth,
		Bitmap.bmHeight,
		Bitmap.bmPlanes * Bitmap.bmBitsPixel );

	// Now allocate memory for the DIB.
	// Then, set the BITMAPINFOHEADER
	//  into this memory, and
	// find out where the bitmap bits go.
	dwSize = ( sizeof(BITMAPINFOHEADER) +
               PaletteSize((LPSTR) &bmInfoHdr) + bmInfoHdr.biSizeImage );
	hDIB = MALLOC( dwSize );
	if( !hDIB )
		return hDIB;

	lpbmInfoHdr  = (LPBITMAPINFOHEADER)hDIB;   // CAST DIB HANDLE
	*lpbmInfoHdr = bmInfoHdr;
	lpBits       = FindDIBBits( (LPSTR)lpbmInfoHdr );

	// Now, we need a DC to hold our bitmap.
	// If the app passed us
	//  a palette, it should be selected into the DC.
	hMemDC = GetDC( NULL );
	if( !hMemDC ) {
		MFREE( hDIB );
		hDIB = NULL;
		return hDIB;
	}

	if( hPal ) {
		hOldPal = SelectPalette( hMemDC, hPal, FALSE );
		RealizePalette( hMemDC );
	}

	// We're finally ready to get the DIB.
	// Call the driver and let it party on our bitmap.
	// It will fill in the color table,
	//  and bitmap bits of our global memory block.
	if( ! GetDIBits( hMemDC,
            		hBitmap,
		            0,
		            Bitmap.bmHeight,
		            lpBits,
		            (LPBITMAPINFO)lpbmInfoHdr,
		            DIB_RGB_COLORS ) )
	{
		MFREE( hDIB );
		hDIB = NULL;
	}

	// Finally, clean up and return.
	if( hOldPal )
		SelectPalette( hMemDC, hOldPal, FALSE );

	ReleaseDC( NULL, hMemDC );

	return hDIB;   // RETURN memory pointer
}

#define  DVGlobalAlloc  GlobalAlloc
#define  DVGlobalLock   GlobalLock
#define  DVGlobalUnlock GlobalUnlock
#define  DVGlobalFree   GlobalFree

// NOTE: Uses GlobalAlloc to get memory
// ====================================
HANDLE DVBitmapToDIB( HBITMAP hBitmap, HPALETTE hPal )
{
	BITMAP				Bitmap;
	BITMAPINFOHEADER	bmInfoHdr;
	LPBITMAPINFOHEADER	lpbmInfoHdr;
	LPSTR				lpBits;
	HDC					hMemDC;
	HANDLE				hDIB;
	HPALETTE			hOldPal;
   size_t         dwSize;

	// Do some setup -- make sure the Bitmap passed in is valid,
	//  get info on the bitmap (like its height, width, etc.),
	//  then setup a BITMAPINFOHEADER.
	hOldPal = NULL;
	hDIB    = NULL;

	if( !hBitmap )
		return hDIB;

	if( !GetObject( hBitmap, sizeof(Bitmap), (LPSTR)&Bitmap ) )
		return hDIB;

	InitBitmapInfoHeader( &bmInfoHdr,
		Bitmap.bmWidth,
		Bitmap.bmHeight,
		Bitmap.bmPlanes * Bitmap.bmBitsPixel );

	// Now allocate memory for the DIB.
	// Then, set the BITMAPINFOHEADER
	//  into this memory, and
	// find out where the bitmap bits go.
	dwSize = ( sizeof(BITMAPINFOHEADER) +
               PaletteSize((LPSTR) &bmInfoHdr) + bmInfoHdr.biSizeImage );
	hDIB = DVGlobalAlloc( GHND, dwSize );
	//hDIB = DVGAlloc( "BMP2DIB", GHND, dwSize );
	//hDIB = (HANDLE)MALLOC( dwSize );
	if( !hDIB )
		return hDIB;

	lpbmInfoHdr  = (LPBITMAPINFOHEADER) DVGlobalLock( hDIB );   // LOCK DIB HANDLE
	//lpbmInfoHdr  = (LPBITMAPINFOHEADER)hDIB;   // LOCK DIB HANDLE
	*lpbmInfoHdr = bmInfoHdr;
	lpBits       = FindDIBBits( (LPSTR)lpbmInfoHdr );

	// Now, we need a DC to hold our bitmap.
	// If the app passed us
	//  a palette, it should be selected into the DC.
	hMemDC = GetDC( NULL );
	if( !hMemDC )
	{
      DVGlobalUnlock(hDIB);
      DVGlobalFree(hDIB);
		//MFREE( hDIB );
		hDIB = NULL;
		return hDIB;
	}

	if( hPal )
	{
		hOldPal = SelectPalette( hMemDC, hPal, FALSE );
		RealizePalette( hMemDC );
	}

	// We're finally ready to get the DIB.
	// Call the driver and let it party on our bitmap.
	// It will fill in the color table,
	//  and bitmap bits of our global memory block.
	if( ! GetDIBits( hMemDC,
            		hBitmap,
		            0,
		            Bitmap.bmHeight,
		            lpBits,
		            (LPBITMAPINFO)lpbmInfoHdr,
		            DIB_RGB_COLORS ) )
	{
		DVGlobalUnlock( hDIB );    // UNLOCK DIB HANDLE - for error FREE and NULL
      DVGlobalFree( hDIB );
		//MFREE( hDIB );
		hDIB = NULL;
	}

	// Finally, clean up and return.
	if( hOldPal )
		SelectPalette( hMemDC, hOldPal, FALSE );

	ReleaseDC( NULL, hMemDC );

	DVGlobalUnlock( hDIB );    // UNLOCK DIB HANDLE
	return hDIB;   // RETURN GlobalAlloc handle

}

/* =============
BI_RGB       An uncompressed format. 
BI_RLE8      A run-length encoded (RLE) format for bitmaps with 8 bpp. The compression format is a 2-byte format consisting of a count byte followed by a byte containing a color index. For more information, see Bitmap Compression.  
BI_RLE4      An RLE format for bitmaps with 4 bpp. The compression format is a 2-byte format consisting of a count byte followed by two word-length color indexes. For more information, see Bitmap Compression. 
BI_BITFIELDS Specifies that the bitmap is not compressed and that the color table
             consists of three DWORD color masks that specify the red, green,
             and blue components, respectively, of each pixel. This is valid
             when used with 16- and 32-bpp bitmaps. 
BI_JPEG      Windows 98/Me, Windows 2000/XP: Indicates that the image is a JPEG image. 
BI_PNG 
  ============== */
DWORD DIBCompression( void * pv )
{
   BITMAPINFOHEADER * pDIBHeader = (BITMAPINFOHEADER *)pv;
   DWORD comp = pDIBHeader->biCompression;
   return comp;
}

PTSTR DIBCompressionStg( void * pv )
{
   DWORD comp = DIBCompression(pv);
   switch( comp )
   {
   case BI_RGB:
      return L"RGB (uncompressed)";
      // LoadString( ghDvInst, IDS_RGB, szBuffer, sizeof(szBuffer));
      break;

   case BI_RLE4:
      return L"RLE4 (with 4 BPP)";
      // LoadString( ghDvInst, IDS_RLE4, szBuffer, sizeof(szBuffer));
      break;

   case BI_RLE8:
      return L"RLE8 (with 8 BPP)";
      // LoadString( ghDvInst, IDS_RLE8, szBuffer, sizeof(szBuffer));
      break;

   case BI_BITFIELDS:
      return L"BITFIELDS (not compressed)";
      break;

   case BI_JPEG:
      return L"JPEG";
      break;

   case BI_PNG:
      return L"PNG";
      break;

	}
   return L"Undetermined";
}

size_t DIBPaletteSize (LPSTR lpbi)
{
   if (IS_WIN30_DIB (lpbi))
      return (DIBNumColors (lpbi) * sizeof (RGBQUAD));
   else
      return (DIBNumColors (lpbi) * sizeof (RGBTRIPLE));
}

size_t PaletteSize (LPSTR lpbi)
{
   return DIBPaletteSize( lpbi );
}

DWORD	DIBBitCount( LPSTR lpbi )
{
	DWORD dwBC;
	if( IS_WIN30_DIB(lpbi) )
		dwBC = ((LPBITMAPINFOHEADER) lpbi)->biBitCount;
	else
		dwBC = ((LPBITMAPCOREHEADER) lpbi)->bcBitCount;
	return( dwBC );
}

// *********************************************************
// SOME OLDER UNUSED ITEM
// *********************************************************

// Only certain bitmaps have a color count
// That is a COLORREF table
DWORD	GetColorCnt( DWORD wBitCount )   // NOT USED?
{
	DWORD	wClrCnt = 0;
	switch( wBitCount ) {
	case 1: wClrCnt = 2; break;
	case 4: wClrCnt = 16; break;
	case 8: wClrCnt = 256; break;
	}
	return wClrCnt;
}

DWORD	CalcDIBColors( LPSTR lpbi )   // NOT USED?
{
	DWORD	dwClrCnt, dwBitCount;
	dwBitCount = DIBBitCount( lpbi);
	dwClrCnt   = GetColorCnt( dwBitCount );
	return dwClrCnt;
}



size_t DIBNumColors_NOT_USED (LPSTR lpbi)   // NOT USED?
{
   size_t wClrCount;

   DWORD dwClrUsed = ((LPBITMAPINFOHEADER) lpbi)->biClrUsed;
   if (dwClrUsed)
      return dwClrUsed;

   // Calculate the number of colors in the color table based on
   //  the number of bits per pixel for the DIB.
	wClrCount = CalcDIBColors( lpbi );
	
	return wClrCount;

}

BOOL DibInfo_NOT_USED (HANDLE hbi, LPBITMAPINFOHEADER lpbi)
{
   if (hbi) {
      lpbi = (LPBITMAPINFOHEADER) hbi;
      /* fill in the default fields */
      if ( lpbi->biSize != sizeof (BITMAPCOREHEADER) ) {
         if (lpbi->biSizeImage == 0L)
            lpbi->biSizeImage = WIDTHBYTES(lpbi->biWidth*lpbi->biBitCount) * lpbi->biHeight;

         if (lpbi->biClrUsed == 0L)
            lpbi->biClrUsed = (DWORD)DIBNumColors (lpbi);
      }
      return TRUE;
   }
   return FALSE;
}

// **********************************************************

// eof - testDib.cxx
